Subject: Re: die cygwin perlld and ld2, die! (was: Trying to build (perl) Inline::CPP-0.25)
From: Steve Peters <[email-masked]>
To: "'pp'" <[email-masked]>
Cc: [email-masked]
Date: Wed, 25 Jul 2007 15:31:31 -0500
List-Id: <cygwin.cygwin.com>

On Wed, Jul 25, 2007 at 10:09:25PM +0200, Reini Urban wrote:
> See the cygwin thread starting with 
> http://cygwin.com/ml/cygwin/2007-07/msg00622.html
> 
> >>I ran into a similar problem recently - the standard sort of c++ 
> >>references were not being found.  It turns out that the linker I was 
> >>calling was ld2, a script that called another script perlld (in 
> >>/usr/bin), where I found this:
> 
> >># these are pretty mandatory
> >>my $CC = 'gcc';
> >>my $EXPORT_ALL = 1;
> 
> >> I edited this script and replaced gcc with g++. I don't know if this
> >> was a good idea or not, but it seemed to fix the problem.
> 
> Reini Urban schrieb:
> >Interesting. We should definitely ask p5p if we shouldn't switch back to 
> >normal behaviour without the ld2 wrapper, but first I must study history 
> >on this issue, why we introduced that at all.
> 
> http://osdir.com/ml/lang.perl.perl5.porters/2003-09/msg01264.html
> 
> "Gerrit: It was introduced because cygwin used dllwrap
> to create dll's which is not a single pass step as creating them with
> gcc -shared -o perl.dll ...
> 
> I would like to get rid of it as soon as possible.  Since gcc
> understands now the -shared flag building shared libs is pretty much
> the same as on e.g. linux besides that we want an import library and
> a shared library (libperl.dll.a & libperl.dll) and also a static
> libperl.a for miniperl.
> 
> So we could use gcc as linker instead of the wrapper ld2, will be just
> a little tricky to get all the ldflags at the right place."
> 
> So I'll get rid of it NOW. But first in perl core, and then in the next 
> cygwin build.
> die! /usr/bin/perlld and /usr/bin/ld2, die!
> 
> Patch soon after proper testing.

Sounds fine to me.  I've run into quite a few problems with ld2 with 
multiple Perls on the same Cygwin installation.

Steve Peters
[email-masked]

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/